// offscrnView.cpp : COffscrnView NX̓̒`s܂B
//

#include "stdafx.h"
#include "offscrn.h"

#include "offscrnDoc.h"
#include "offscrnView.h"

#include "GL/glext.h"
#include "GL/wglext.h"


PFNGLISRENDERBUFFEREXTPROC				glIsRenderbufferEXT = NULL;
PFNGLBINDRENDERBUFFEREXTPROC			glBindRenderbufferEXT = NULL;
PFNGLDELETERENDERBUFFERSEXTPROC			glDeleteRenderbuffersEXT = NULL;
PFNGLGENRENDERBUFFERSEXTPROC			glGenRenderbuffersEXT = NULL;
PFNGLRENDERBUFFERSTORAGEEXTPROC			glRenderbufferStorageEXT = NULL;
PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC	glGetRenderbufferParameterivEXT = NULL;
PFNGLISFRAMEBUFFEREXTPROC				glIsFramebufferEXT = NULL;
PFNGLBINDFRAMEBUFFEREXTPROC glBindFramebufferEXT = NULL;
PFNGLDELETEFRAMEBUFFERSEXTPROC			glDeleteFramebuffersEXT = NULL;
PFNGLGENFRAMEBUFFERSEXTPROC				glGenFramebuffersEXT = NULL;
PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC		glCheckFramebufferStatusEXT = NULL;
PFNGLFRAMEBUFFERTEXTURE1DEXTPROC		glFramebufferTexture1DEXT = NULL;
PFNGLFRAMEBUFFERTEXTURE2DEXTPROC		glFramebufferTexture2DEXT = NULL;
PFNGLFRAMEBUFFERTEXTURE3DEXTPROC		glFramebufferTexture3DEXT = NULL;
PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC		glFramebufferRenderbufferEXT = NULL;
PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC	glGetFramebufferAttachmentParameterivEXT = NULL;
PFNGLGENERATEMIPMAPEXTPROC				glGenerateMipmapEXT = NULL;

#include <math.h>

#ifndef	M_PI
#	define	M_PI	3.1415926
#endif	/* M_PI */



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COffscrnView

IMPLEMENT_DYNCREATE(COffscrnView, CView)

BEGIN_MESSAGE_MAP(COffscrnView, CView)
	//{{AFX_MSG_MAP(COffscrnView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̍\z/

COffscrnView::COffscrnView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

	m_hRC = NULL;

	m_colorTex = 0;
	m_depth = 0;
}

COffscrnView::~COffscrnView()
{
}

BOOL COffscrnView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̕`

void COffscrnView::OnDraw(CDC* pDC)
{
	COffscrnDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B

	::wglMakeCurrent(pDC->m_hDC, m_hRC);

	::glBindTexture(GL_TEXTURE_2D, 0);
	::glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb);

	::glViewport(0, 0, 2048, 2048);

	// ݒ
	InitOGL();

	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity(); 
	::gluPerspective(45.0f, (float)m_cx / (float)m_cy, 1.0f, 2000.0f);
	::glMatrixMode(GL_MODELVIEW);
	::glLoadIdentity(); 

	::glPushMatrix();

	::gluLookAt(
		0.0f, 0.0f, 600.0f,
		0.0f, 0.0f, 0.0f,
		0.0f, 1.0f, 0.0f
	);


	GLfloat	pos[]		= {1800.0f, 1800.0f, 2300.0f, 1.0f};
	GLfloat	col_amb[]	= {0.2f, 0.2f, 0.2f, 1.0f};
	GLfloat	col_diff[]	= {1.0f, 1.0f, 1.0f, 1.0f};
	GLfloat	col_spec[]	= {1.0f, 1.0f, 1.0f, 1.0f};

	::glLightfv(GL_LIGHT1, GL_AMBIENT, col_amb);
	::glLightfv(GL_LIGHT1, GL_DIFFUSE, col_diff);
	::glLightfv(GL_LIGHT1, GL_SPECULAR, col_spec);
	::glLightfv(GL_LIGHT1, GL_POSITION, pos);


	GLfloat	mat_ambient[]  = {0.15f, 0.15f, 0.70f, 1.0f};
	GLfloat	mat_diffuse[]  = {0.15f, 0.15f, 0.70f, 1.0f};
	GLfloat	mat_specular[] = {1.0f, 1.0f, 1.0f, 1.0f};

	::glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
	::glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	::glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	::glMaterialf(GL_FRONT, GL_SHININESS, 64.0);

	::glPushMatrix();
	DrawSphere(200.0);
	::glPopMatrix();

	::glPopMatrix();
	::glFlush();

	/******/

	::glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
	::glBindTexture(GL_TEXTURE_2D, m_colorTex);

	::glViewport(0, 0, m_cx, m_cy);

	::glDisable(GL_LIGHTING);

	::glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity(); 
	::gluOrtho2D(0.0f, 1.0f, 0.0f, 1.0f);
	::glMatrixMode(GL_MODELVIEW);
	::glLoadIdentity(); 

	::glPixelStorei(GL_UNPACK_ALIGNMENT, 8);
	::glPixelStorei(GL_PACK_ALIGNMENT, 8);

	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	::glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	::glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

	::glEnable(GL_TEXTURE_2D);

	::glColor3f(1.0f, 1.0f, 1.0f);
	::glBegin(GL_POLYGON);
	::glTexCoord2f(0.0f, 0.0f);
	::glVertex2f(0.0f, 0.0f);
	::glTexCoord2f(1.0f, 0.0f);
	::glVertex2f(1.0f, 0.0f);
	::glTexCoord2f(1.0f, 1.0f);
	::glVertex2f(1.0f, 1.0f);
	::glTexCoord2f(0.0f, 1.0f);
	::glVertex2f(0.0f, 1.0f);
	::glEnd();

	::glDisable(GL_TEXTURE_2D);

	::glFlush();

	::wglMakeCurrent(NULL, NULL);
}

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̐ff

#ifdef _DEBUG
void COffscrnView::AssertValid() const
{
	CView::AssertValid();
}

void COffscrnView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

COffscrnDoc* COffscrnView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COffscrnDoc)));
	return (COffscrnDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COffscrnView NX̃bZ[W nh

int COffscrnView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ

	PIXELFORMATDESCRIPTOR pfd = { 
		sizeof(PIXELFORMATDESCRIPTOR),  //  size of this pfd 
		1,                     // version number 
		PFD_DRAW_TO_WINDOW |   // WINDOW w肷邱
		PFD_SUPPORT_OPENGL,    // support OpenGL 
		PFD_TYPE_RGBA,         // RGBA type 
		24,                    // 24-bit color depth 
		0, 0, 0, 0, 0, 0,      // color bits ignored 
		0,                     // no alpha buffer 
		0,                     // shift bit ignored 
		0,                     // no accumulation buffer 
		0, 0, 0, 0,            // accum bits ignored 
		32,                    // 32-bit z-buffer     
		0,                     // no stencil buffer 
		0,                     // no auxiliary buffer 
		PFD_MAIN_PLANE,        // main layer 
		0,                     // reserved 
		0, 0, 0                // layer masks ignored 
	}; 

	CClientDC	dc(this);


	int  iPixelFormat; 
 
	iPixelFormat = ::ChoosePixelFormat(dc.m_hDC, &pfd);
	BOOL success = ::SetPixelFormat(dc.m_hDC, iPixelFormat, &pfd);

	m_hRC = ::wglCreateContext(dc.m_hDC);

	::wglMakeCurrent(dc.m_hDC, m_hRC);

	{
		const GLubyte *extensions;
		char *p;
		int pass = 0;

		extensions = glGetString(GL_EXTENSIONS);

		p = strtok((char *)extensions, " ");

		TRACE("GL_EXTENSIONS: \n");
		while(p != NULL) {
			TRACE("  %s\n", p);
			if (!strcmp("GL_EXT_framebuffer_object", p)) {
				pass = 1;
			}
			p = strtok(NULL, " ");
		}

		if (!pass) {
			MessageBox(_T("Not support GL_OES_matrix_palette"), _T("ERROR"), MB_ICONERROR);
			return -1;
		}


		int val;
		::glGetIntegerv(GL_MAX_RENDERBUFFER_SIZE_EXT, &val);
		CString msg;
		msg.Format("GL_MAX_RENDERBUFFER_SIZE_EXT : %d\n", val);
		TRACE(msg);
	}


	glIsRenderbufferEXT = (PFNGLISRENDERBUFFEREXTPROC)::wglGetProcAddress("glIsRenderbufferEXT");
	glBindRenderbufferEXT = (PFNGLBINDRENDERBUFFEREXTPROC)::wglGetProcAddress("glBindRenderbufferEXT");
	glDeleteRenderbuffersEXT = (PFNGLDELETERENDERBUFFERSEXTPROC)::wglGetProcAddress("glDeleteRenderbuffersEXT");
	glGenRenderbuffersEXT = (PFNGLGENRENDERBUFFERSEXTPROC)::wglGetProcAddress("glGenRenderbuffersEXT");
	glRenderbufferStorageEXT = (PFNGLRENDERBUFFERSTORAGEEXTPROC)::wglGetProcAddress("glRenderbufferStorageEXT");
	glGetRenderbufferParameterivEXT = (PFNGLGETRENDERBUFFERPARAMETERIVEXTPROC)::wglGetProcAddress("glGetRenderbufferParameterivEXT");
	glIsFramebufferEXT = (PFNGLISFRAMEBUFFEREXTPROC)::wglGetProcAddress("glIsFramebufferEXT");
	glBindFramebufferEXT = (PFNGLBINDFRAMEBUFFEREXTPROC)::wglGetProcAddress("glBindFramebufferEXT");
	glDeleteFramebuffersEXT = (PFNGLDELETEFRAMEBUFFERSEXTPROC)::wglGetProcAddress("glDeleteFramebuffersEXT");
	glGenFramebuffersEXT = (PFNGLGENFRAMEBUFFERSEXTPROC)::wglGetProcAddress("glGenFramebuffersEXT");
	glCheckFramebufferStatusEXT = (PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC)::wglGetProcAddress("glCheckFramebufferStatusEXT");
	glFramebufferTexture1DEXT = (PFNGLFRAMEBUFFERTEXTURE1DEXTPROC)::wglGetProcAddress("glFramebufferTexture1DEXT");
	glFramebufferTexture2DEXT = (PFNGLFRAMEBUFFERTEXTURE2DEXTPROC)::wglGetProcAddress("glFramebufferTexture2DEXT");
	glFramebufferTexture3DEXT = (PFNGLFRAMEBUFFERTEXTURE3DEXTPROC)::wglGetProcAddress("glFramebufferTexture3DEXT");
	glFramebufferRenderbufferEXT = (PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC)::wglGetProcAddress("glFramebufferRenderbufferEXT");
	glGetFramebufferAttachmentParameterivEXT = (PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVEXTPROC)::wglGetProcAddress("glGetFramebufferAttachmentParameterivEXT");
	glGenerateMipmapEXT = (PFNGLGENERATEMIPMAPEXTPROC)::wglGetProcAddress("glGenerateMipmapEXT");


	::glGenTextures(1, &m_colorTex);

	// initialize color texture
	::glBindTexture(GL_TEXTURE_2D, m_colorTex);
	::glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	::glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	::glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB8, 2048, 2048, 0,
		 GL_RGBA, GL_UNSIGNED_BYTE, NULL);


	::glGenFramebuffersEXT(1, &m_fb);
	::glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb);

	::glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,
					  GL_COLOR_ATTACHMENT0_EXT,
					  GL_TEXTURE_2D, m_colorTex, 0);

	::glGenRenderbuffersEXT(1, &m_depth);
	::glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, m_depth);
	::glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT24, 2048, 2048);
	::glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT,
		GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, m_depth);

	// Check framebuffer completeness at the end of initialization.
	if (::glCheckFramebufferStatusEXT(GL_FRAMEBUFFER_EXT) != GL_FRAMEBUFFER_COMPLETE_EXT) {
		::glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
		::glFlush();

		::wglMakeCurrent(NULL, NULL);		
		return -1;
	}

	::glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
	::glFlush();

	::wglMakeCurrent(NULL, NULL);

	return 0;
}

void COffscrnView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ

	if (cx <= 0 || cy <= 0) {
		return;
	}

	/*  */
	m_cx = cx;
	m_cy = cy;
}

void COffscrnView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ

	if (m_colorTex) {
		::glDeleteTextures(1, &m_colorTex);
	}
	if (m_depth) {
		::glDeleteRenderbuffersEXT(1, &m_depth);
	}

	::wglDeleteContext(m_hRC);
}

BOOL COffscrnView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
//	return CView::OnEraseBkgnd(pDC);

	return TRUE;
}

void COffscrnView::InitOGL(void)
{
	::glClearColor(0.68f, 0.68f, 0.68f, 1.0f);

	::glShadeModel(GL_SMOOTH);
	::glEnable(GL_DEPTH_TEST);
	::glEnable(GL_CULL_FACE);
	::glEnable(GL_LIGHTING);
	::glEnable(GL_LIGHT1);

	::glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
}

void COffscrnView::DrawSphere(double radius)
{
	double	theta, pai;
	double	co, si;
	double	co2, si2;
	double	r1, r2;
	double	h1, h2;

	for(pai = -90.0; pai < 90.0; pai += 10.0) {
		r1 = cos(pai * M_PI / 180.0);
		r2 = cos((pai + 10.0) * M_PI / 180.0);
		h1 = sin(pai * M_PI / 180.0);
		h2 = sin((pai + 10.0) * M_PI / 180.0);

		for(theta = 0.0; theta < 360.0; theta += 10.0) {
			co = cos(theta * M_PI / 180.0);
			si = sin(theta * M_PI / 180.0);
			co2 = cos((theta + 10.0) * M_PI / 180.0);
			si2 = sin((theta + 10.0) * M_PI / 180.0);

			::glBegin(GL_POLYGON);
			::glNormal3f((float)(r1 * co2), (float)h1, (float)(r1 * si2));
			::glVertex3f((float)(radius * r1 * co2), (float)(radius * h1), (float)(radius * r1 * si2));
			::glNormal3f((float)(r1 * co), (float)h1, (float)(r1 * si));
			::glVertex3f((float)(radius * r1 * co), (float)(radius * h1), (float)(radius * r1 * si));
			::glNormal3f((float)(r2 * co), (float)h2, (float)(r2 * si));
			::glVertex3f((float)(radius * r2 * co), (float)(radius * h2), (float)(radius * r2 * si));
			::glNormal3f((float)(r2 * co2), (float)h2, (float)(r2 * si2));
			::glVertex3f((float)(radius * r2 * co2), (float)(radius * h2), (float)(radius * r2 * si2));
			::glEnd();
		}
	}
}
